// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S064_RvNumbers.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;


@SuppressWarnings("fallthrough")
class S064_RvNumbers extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int rvNumberState = 4;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2, 2
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\34\u0200\1\u0300\1\u0200\1\u0400\1\u0500\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\3\22\0\1\1"+
    "\1\0\1\4\3\0\1\5\5\0\1\6\1\7\1\10"+
    "\1\11\12\12\1\13\1\14\5\0\1\15\1\16\1\17"+
    "\1\20\1\21\3\17\1\22\1\17\1\23\1\24\1\25"+
    "\1\26\1\27\1\30\1\17\1\31\1\32\1\33\1\34"+
    "\1\35\1\36\3\17\1\37\1\0\1\40\1\0\1\41"+
    "\1\0\1\42\1\43\1\44\1\45\1\46\3\44\1\47"+
    "\1\44\1\50\1\51\1\52\1\53\1\54\1\55\1\44"+
    "\1\56\1\57\1\60\1\61\1\62\1\63\3\44\65\0"+
    "\1\64\17\0\6\44\1\0\11\44\1\0\6\44\2\0"+
    "\4\44\3\0\6\44\1\0\11\44\1\0\6\44\2\0"+
    "\4\44\53\0\2\44\6\0\2\65\66\0\2\44\4\0"+
    "\2\44\17\0\1\66\u0188\0\2\44\216\0\2\44\42\0"+
    "\2\44\104\0\1\1\20\0\2\7\u0115\0\1\67\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1536];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\3\0\4\1\2\2\1\3\1\4\1\3\21\0\5\5"+
    "\1\0\1\5\47\0\4\5\1\0\1\6\56\0\1\5"+
    "\42\0\1\7\16\0\1\10\50\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[218];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\70\0\160\0\250\0\340\0\u0118\0\u0150\0\u0118"+
    "\0\u0188\0\u0118\0\u01c0\0\u01f8\0\u0230\0\u0268\0\250\0\u02a0"+
    "\0\u02d8\0\u0310\0\u0348\0\u0380\0\u03b8\0\u03f0\0\u0428\0\u0460"+
    "\0\u0498\0\u04d0\0\u0508\0\u0540\0\u0578\0\u0118\0\u05b0\0\u05e8"+
    "\0\u0620\0\u0658\0\u0690\0\u06c8\0\u0700\0\u0738\0\u0770\0\u05b0"+
    "\0\u07a8\0\u07e0\0\u0818\0\u0850\0\u0888\0\u08c0\0\u08f8\0\u0930"+
    "\0\u0968\0\u09a0\0\u09d8\0\u0a10\0\u0a48\0\u0a80\0\u0620\0\u0658"+
    "\0\u06c8\0\u0ab8\0\u0af0\0\u0b28\0\u0b60\0\u0b98\0\u0bd0\0\u0c08"+
    "\0\u0c40\0\u0c78\0\u0cb0\0\u0ce8\0\u0d20\0\u0d58\0\u0d90\0\u0dc8"+
    "\0\u0e00\0\u0e38\0\u0e70\0\u0ea8\0\u0ee0\0\u0f18\0\u0f50\0\u0f88"+
    "\0\u0118\0\u0fc0\0\u0ff8\0\u1030\0\u1068\0\u10a0\0\u10d8\0\u1110"+
    "\0\u1148\0\u1180\0\u11b8\0\u11f0\0\u1228\0\u1260\0\u1298\0\u12d0"+
    "\0\u1308\0\u1340\0\u1378\0\u13b0\0\u13e8\0\u0ea8\0\u0f18\0\u0f50"+
    "\0\u1420\0\u1458\0\u1490\0\u14c8\0\u1500\0\u1538\0\u1570\0\u15a8"+
    "\0\u15e0\0\u1618\0\u1650\0\u1688\0\u16c0\0\u16f8\0\u1730\0\u1768"+
    "\0\u17a0\0\u17d8\0\u1810\0\u1848\0\u1880\0\u18b8\0\u18f0\0\u1928"+
    "\0\u1960\0\u1998\0\u19d0\0\u1a08\0\u1a40\0\u1a78\0\u1ab0\0\u1ae8"+
    "\0\u1b20\0\u1b58\0\u1b90\0\u1bc8\0\u1c00\0\u1c38\0\u1c70\0\u1ca8"+
    "\0\u1ce0\0\u1d18\0\u1d50\0\u1d88\0\u1dc0\0\u1df8\0\u1e30\0\u1e68"+
    "\0\u1ea0\0\u1ed8\0\u1f10\0\u1f48\0\u1f80\0\u1fb8\0\u1ff0\0\u2028"+
    "\0\u2060\0\u2098\0\u0118\0\u20d0\0\u2108\0\u2140\0\u2178\0\u21b0"+
    "\0\u21e8\0\u2220\0\u2258\0\u2290\0\u22c8\0\u2300\0\u2338\0\u2370"+
    "\0\u23a8\0\u0118\0\u23e0\0\u2418\0\u2450\0\u2488\0\u24c0\0\u24f8"+
    "\0\u2530\0\u2568\0\u25a0\0\u25d8\0\u2610\0\u2648\0\u2680\0\u26b8"+
    "\0\u26f0\0\u2728\0\u2760\0\u2798\0\u27d0\0\u2808\0\u2840\0\u2878"+
    "\0\u28b0\0\u28e8\0\u2920\0\u2958\0\u2990\0\u29c8\0\u2a00\0\u2a38"+
    "\0\u2a70\0\u2aa8\0\u2ae0\0\u2b18\0\u2b50\0\u2b88\0\u2bc0\0\u2bf8"+
    "\0\u2c30\0\u2c68";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[218];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\3\4\1\5\4\4\1\6\1\4\1\6\2\4\22\6"+
    "\1\7\2\4\22\6\4\4\37\10\1\11\30\10\12\12"+
    "\1\13\24\12\1\14\30\12\25\0\1\15\3\0\1\16"+
    "\20\0\1\15\3\0\1\16\13\0\1\17\22\0\1\15"+
    "\3\0\1\16\20\0\1\15\3\0\1\16\125\0\1\20"+
    "\1\15\3\0\1\16\17\0\1\20\1\15\3\0\1\16"+
    "\22\0\1\21\70\0\1\13\101\0\1\22\24\0\1\22"+
    "\17\0\3\23\1\0\1\24\2\0\1\23\1\0\1\25"+
    "\2\0\1\26\7\0\1\27\1\30\13\0\1\26\7\0"+
    "\1\27\1\30\51\0\1\31\24\0\1\31\30\0\1\32"+
    "\24\0\1\32\16\0\1\32\24\0\1\33\24\0\1\33"+
    "\41\0\1\34\24\0\1\34\16\0\1\34\1\0\3\23"+
    "\1\0\1\24\4\0\1\25\12\0\1\27\1\30\23\0"+
    "\1\27\1\30\42\0\1\35\24\0\1\35\14\0\1\36"+
    "\2\37\1\40\1\36\1\41\1\37\1\42\2\36\1\25"+
    "\2\36\10\0\1\43\11\0\1\44\1\36\1\42\10\0"+
    "\1\43\11\0\4\36\32\0\1\45\24\0\1\45\6\0"+
    "\1\45\2\0\3\46\1\0\1\47\2\0\1\46\1\0"+
    "\1\50\2\0\1\51\10\0\1\52\13\0\1\51\10\0"+
    "\1\52\15\0\3\53\1\0\1\54\2\0\1\55\1\0"+
    "\1\25\12\0\1\27\2\56\1\0\1\56\2\0\1\57"+
    "\15\0\1\27\2\56\1\0\1\56\2\0\1\57\2\0"+
    "\1\53\4\0\3\60\1\0\1\61\2\0\1\60\1\0"+
    "\1\62\103\0\1\63\24\0\1\63\37\0\1\64\24\0"+
    "\1\64\16\0\1\64\26\0\1\65\24\0\1\65\32\0"+
    "\1\66\24\0\1\66\25\0\3\50\1\0\1\67\1\50"+
    "\1\70\2\0\1\25\12\0\1\43\11\0\1\71\1\0"+
    "\1\70\10\0\1\43\16\0\1\50\1\37\1\50\1\0"+
    "\1\67\1\50\1\70\2\0\1\25\12\0\1\43\11\0"+
    "\1\71\1\0\1\70\10\0\1\43\43\0\1\72\24\0"+
    "\1\72\15\0\3\70\1\0\1\73\2\70\2\0\1\25"+
    "\12\0\1\43\13\0\1\70\10\0\1\43\16\0\3\74"+
    "\1\0\1\75\2\0\1\74\1\0\1\25\2\0\1\76"+
    "\10\0\1\77\13\0\1\76\10\0\1\77\40\0\1\100"+
    "\24\0\1\100\50\0\1\101\24\0\1\101\6\0\1\101"+
    "\2\0\3\46\1\0\1\47\4\0\1\50\13\0\1\52"+
    "\24\0\1\52\42\0\1\102\24\0\1\102\46\0\1\103"+
    "\24\0\1\103\6\0\1\103\2\0\3\104\1\0\1\105"+
    "\2\0\1\106\1\0\1\50\13\0\2\107\1\0\1\107"+
    "\2\0\1\110\16\0\2\107\1\0\1\107\2\0\1\110"+
    "\2\0\1\104\4\0\3\53\1\0\1\54\4\0\1\25"+
    "\12\0\1\27\24\0\1\27\43\0\1\111\24\0\1\111"+
    "\15\0\3\53\1\0\1\54\4\0\1\25\12\0\1\27"+
    "\24\0\1\27\11\0\1\53\4\0\3\53\1\0\1\54"+
    "\2\0\1\53\1\0\1\25\12\0\1\27\24\0\1\27"+
    "\42\0\1\112\24\0\1\112\16\0\3\60\1\0\1\61"+
    "\4\0\1\62\103\0\1\113\24\0\1\113\14\0\1\36"+
    "\2\114\1\115\1\36\1\116\1\36\1\117\2\36\1\62"+
    "\2\36\22\0\2\36\1\117\22\0\4\36\13\0\1\120"+
    "\102\0\1\121\24\0\1\121\27\0\1\122\106\0\1\123"+
    "\24\0\1\123\6\0\1\123\17\0\1\124\24\0\1\124"+
    "\52\0\1\125\24\0\1\125\15\0\3\74\1\0\1\75"+
    "\4\0\1\25\13\0\1\77\24\0\1\77\42\0\1\126"+
    "\24\0\1\126\46\0\1\127\24\0\1\127\6\0\1\127"+
    "\2\0\3\130\1\0\1\131\2\0\1\132\1\0\1\25"+
    "\13\0\2\133\1\0\1\133\2\0\1\134\16\0\2\133"+
    "\1\0\1\133\2\0\1\134\2\0\1\130\26\0\1\135"+
    "\24\0\1\135\16\0\1\135\1\0\3\23\1\0\1\24"+
    "\2\0\1\23\1\0\1\25\7\0\1\136\2\0\1\27"+
    "\1\30\20\0\1\136\2\0\1\27\1\30\11\0\1\136"+
    "\20\0\1\137\24\0\1\137\56\0\1\140\24\0\1\140"+
    "\6\0\1\140\2\0\3\104\1\0\1\105\4\0\1\50"+
    "\103\0\1\141\24\0\1\141\15\0\3\104\1\0\1\105"+
    "\4\0\1\50\51\0\1\104\4\0\3\104\1\0\1\105"+
    "\2\0\1\104\1\0\1\50\102\0\1\142\24\0\1\142"+
    "\33\0\1\143\24\0\1\143\25\0\3\53\1\0\1\54"+
    "\2\0\1\53\1\0\1\25\6\0\1\144\3\0\1\27"+
    "\20\0\1\144\3\0\1\27\33\0\1\145\24\0\1\145"+
    "\25\0\3\146\1\0\1\147\1\0\1\150\31\0\1\150"+
    "\27\0\1\146\1\114\1\146\1\0\1\147\1\0\1\150"+
    "\31\0\1\150\54\0\1\151\24\0\1\151\15\0\3\150"+
    "\1\0\1\152\4\0\1\153\72\0\22\154\2\0\1\154"+
    "\43\0\22\155\2\0\1\155\56\0\1\156\24\0\1\156"+
    "\44\0\1\157\24\0\1\157\6\0\1\157\17\0\1\160"+
    "\24\0\1\160\42\0\1\161\24\0\1\161\56\0\1\162"+
    "\24\0\1\162\6\0\1\162\2\0\3\130\1\0\1\131"+
    "\4\0\1\25\103\0\1\163\24\0\1\163\15\0\3\130"+
    "\1\0\1\131\4\0\1\25\51\0\1\130\4\0\3\130"+
    "\1\0\1\131\2\0\1\130\1\0\1\25\102\0\1\164"+
    "\24\0\1\164\43\0\1\165\24\0\1\165\41\0\1\166"+
    "\24\0\1\166\47\0\1\167\24\0\1\167\6\0\1\167"+
    "\2\0\3\46\1\0\1\47\2\0\1\46\1\0\1\50"+
    "\7\0\1\170\3\0\1\52\20\0\1\170\3\0\1\52"+
    "\11\0\1\170\20\0\1\171\24\0\1\171\25\0\3\104"+
    "\1\0\1\105\2\0\1\104\1\0\1\50\6\0\1\172"+
    "\24\0\1\172\53\0\1\173\24\0\1\173\6\0\1\173"+
    "\32\0\1\174\24\0\1\174\43\0\1\175\24\0\1\175"+
    "\6\0\1\175\17\0\1\176\24\0\1\176\52\0\1\177"+
    "\24\0\1\177\14\0\3\36\1\200\6\36\1\201\2\36"+
    "\22\0\3\36\22\0\4\36\13\0\1\202\1\0\22\154"+
    "\2\0\1\154\41\0\1\203\1\0\22\155\2\0\1\155"+
    "\42\0\1\23\103\0\1\204\24\0\1\204\44\0\1\205"+
    "\24\0\1\205\6\0\1\205\33\0\1\206\24\0\1\206"+
    "\6\0\1\206\2\0\3\74\1\0\1\75\2\0\1\74"+
    "\1\0\1\25\7\0\1\207\3\0\1\77\20\0\1\207"+
    "\3\0\1\77\11\0\1\207\20\0\1\210\24\0\1\210"+
    "\25\0\3\130\1\0\1\131\2\0\1\130\1\0\1\25"+
    "\6\0\1\211\24\0\1\211\34\0\1\212\71\0\1\23"+
    "\3\0\1\23\20\0\1\23\3\0\1\23\51\0\1\213"+
    "\24\0\1\213\37\0\1\214\24\0\1\214\47\0\1\215"+
    "\24\0\1\215\6\0\1\215\32\0\1\216\24\0\1\216"+
    "\41\0\1\217\24\0\1\217\34\0\1\53\4\0\1\53"+
    "\17\0\1\53\4\0\1\53\10\0\1\53\32\0\1\220"+
    "\24\0\1\220\44\0\1\221\24\0\1\221\6\0\1\221"+
    "\17\0\1\222\24\0\1\222\26\0\1\36\65\0\3\36"+
    "\1\200\6\36\1\0\2\36\22\0\3\36\22\0\4\36"+
    "\2\202\3\0\6\202\1\223\23\202\2\0\27\202\2\203"+
    "\3\0\6\203\1\224\23\203\2\0\27\203\14\0\1\50"+
    "\103\0\1\225\24\0\1\225\42\0\1\226\24\0\1\226"+
    "\37\0\1\227\24\0\1\227\47\0\1\230\24\0\1\230"+
    "\6\0\1\230\32\0\1\231\24\0\1\231\43\0\1\232"+
    "\24\0\1\232\6\0\1\232\15\0\1\46\70\0\1\46"+
    "\3\0\1\46\20\0\1\46\3\0\1\46\51\0\1\233"+
    "\24\0\1\233\34\0\1\104\4\0\1\104\17\0\1\104"+
    "\4\0\1\104\10\0\1\104\16\0\1\53\67\0\1\60"+
    "\103\0\1\234\24\0\1\234\44\0\1\235\24\0\1\235"+
    "\6\0\1\235\13\0\1\236\67\0\1\237\71\0\1\70"+
    "\67\0\1\74\70\0\1\74\3\0\1\74\20\0\1\74"+
    "\3\0\1\74\51\0\1\240\24\0\1\240\34\0\1\130"+
    "\4\0\1\130\17\0\1\130\4\0\1\130\10\0\1\130"+
    "\35\0\1\241\24\0\1\241\23\0\1\104\67\0\1\146"+
    "\103\0\1\242\24\0\1\242\24\0\1\236\25\0\1\243"+
    "\41\0\1\237\25\0\1\244\43\0\1\130\103\0\1\245"+
    "\24\0\1\245\26\0\1\150\53\0\37\246\1\0\30\246"+
    "\36\0\1\247\24\0\1\247\4\0\37\246\1\250\30\246"+
    "\13\0\1\251\65\0\1\252\73\0\1\253\24\0\1\253"+
    "\51\0\1\254\24\0\1\254\44\0\1\255\24\0\1\255"+
    "\37\0\1\256\24\0\1\256\16\0\1\256\20\0\1\257"+
    "\24\0\1\257\50\0\1\260\24\0\1\260\27\0\1\261"+
    "\114\0\1\262\41\0\1\263\67\0\1\263\25\0\1\264"+
    "\27\0\37\265\1\0\67\265\1\266\30\265\11\0\1\267"+
    "\102\0\1\270\24\0\1\270\41\0\1\271\24\0\1\271"+
    "\16\0\1\271\26\0\1\272\24\0\1\272\54\0\1\273"+
    "\30\0\3\273\1\0\1\274\4\0\1\275\12\0\1\276"+
    "\24\0\1\276\43\0\1\277\24\0\1\277\14\0\3\36"+
    "\1\200\6\36\1\275\2\36\22\0\3\36\22\0\4\36"+
    "\1\0\3\300\1\0\1\301\2\0\1\300\1\0\1\275"+
    "\2\0\1\302\10\0\1\303\13\0\1\302\10\0\1\303"+
    "\32\0\1\304\24\0\1\304\25\0\3\300\1\0\1\301"+
    "\4\0\1\275\13\0\1\303\24\0\1\303\42\0\1\305"+
    "\24\0\1\305\46\0\1\306\24\0\1\306\6\0\1\306"+
    "\2\0\3\307\1\0\1\310\2\0\1\311\1\0\1\275"+
    "\13\0\2\312\1\0\1\312\2\0\1\313\16\0\2\312"+
    "\1\0\1\312\2\0\1\313\2\0\1\307\35\0\1\314"+
    "\24\0\1\314\6\0\1\314\17\0\1\315\24\0\1\315"+
    "\56\0\1\316\24\0\1\316\6\0\1\316\2\0\3\307"+
    "\1\0\1\310\4\0\1\275\103\0\1\317\24\0\1\317"+
    "\15\0\3\307\1\0\1\310\4\0\1\275\51\0\1\307"+
    "\4\0\3\307\1\0\1\310\2\0\1\307\1\0\1\275"+
    "\102\0\1\320\24\0\1\320\45\0\1\321\24\0\1\321"+
    "\44\0\1\322\24\0\1\322\6\0\1\322\2\0\3\300"+
    "\1\0\1\301\2\0\1\300\1\0\1\275\7\0\1\323"+
    "\3\0\1\303\20\0\1\323\3\0\1\303\11\0\1\323"+
    "\20\0\1\324\24\0\1\324\25\0\3\307\1\0\1\310"+
    "\2\0\1\307\1\0\1\275\6\0\1\325\24\0\1\325"+
    "\35\0\1\273\103\0\1\326\24\0\1\326\37\0\1\327"+
    "\24\0\1\327\47\0\1\330\24\0\1\330\6\0\1\330"+
    "\32\0\1\331\24\0\1\331\25\0\1\300\70\0\1\300"+
    "\3\0\1\300\20\0\1\300\3\0\1\300\51\0\1\332"+
    "\24\0\1\332\34\0\1\307\4\0\1\307\17\0\1\307"+
    "\4\0\1\307\10\0\1\307\16\0\1\307\53\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[11424];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\3\0\2\1\1\11\1\1\1\11\1\1\1\11\2\1"+
    "\21\0\1\11\4\1\1\0\1\1\47\0\4\1\1\0"+
    "\1\11\56\0\1\1\42\0\1\11\16\0\1\11\50\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[218];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S064_RvNumbers() { }
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S064_RvNumbers(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 9: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 10: break;
          case 3:
            { checkEnd();
            }
          // fall through
          case 11: break;
          case 4:
            { if( !checkEdge()) {
		
			if( !annotationEntity.getValue().equals("")) 
				annotationEntity.setValue(annotationEntity.getValue() + ";");
				
			annotationEntity.setValue(annotationEntity.getValue() + yytext());
			
			offset += yylength();
			position += yylength();
		}
            }
          // fall through
          case 12: break;
          case 5:
            { start(new AnnotationEntity(Entity.RV_NUMBER), rvNumberState, true, true);
            }
          // fall through
          case 13: break;
          case 6:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 14: break;
          case 7:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 15: break;
          case 8:
            { if( !checkEdge()) {
		
			AnnotationEntity retrievedEntity = retrieveEntity();
			
			offset += yylength();
			position += retrievedEntity.getText().length();
		}
            }
          // fall through
          case 16: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S064_RvNumbers [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S064_RvNumbers scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S064_RvNumbers(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
